#!/bin/sh
# $OpenLDAP: pkg/ldap/tests/run.in,v 1.28.2.16 2006/01/03 22:16:27 kurt Exp $
## This work is part of OpenLDAP Software <http://www.openldap.org/>.
##
## Copyright 1998-2006 The OpenLDAP Foundation.
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted only as authorized by the OpenLDAP
## Public License.
##
## A copy of this license is available in the file LICENSE in the
## top-level directory of the distribution or, alternatively, at
## <http://www.OpenLDAP.org/license.html>.

USAGE="$0 [-b <backend>] [-c] [-k] [-p] [-u] [-w] <script>"

# configure generated
SRCDIR="@srcdir@"
TOPSRCDIR="@top_srcdir@"
LN_S="@LN_S@"
EGREP_CMD="@EGREP@"

export SRCDIR TOPSRCDIR LN_S EGREP_CMD

# backends
AC_bdb=@BUILD_BDB@
AC_hdb=@BUILD_HDB@
AC_ldap=ldap@BUILD_LDAP@
AC_ldbm=@BUILD_LDBM@
AC_meta=meta@BUILD_META@
AC_monitor=@BUILD_MONITOR@
AC_relay=relay@BUILD_RELAY@
AC_sql=sql@BUILD_SQL@

# overlays
AC_accesslog=accesslog@BUILD_ACCESSLOG@
AC_dynlist=dynlist@BUILD_DYNLIST@
AC_pcache=pcache@BUILD_PROXYCACHE@
AC_ppolicy=ppolicy@BUILD_PPOLICY@
AC_refint=refint@BUILD_REFINT@
AC_retcode=retcode@BUILD_RETCODE@
AC_translucent=translucent@BUILD_TRANSLUCENT@
AC_unique=unique@BUILD_UNIQUE@
AC_rwm=rwm@BUILD_RWM@
AC_syncprov=syncprov@BUILD_SYNCPROV@
AC_valsort=valsort@BUILD_VALSORT@

# misc
AC_WITH_SASL=@WITH_SASL@
AC_WITH_TLS=@WITH_TLS@
AC_WITH_MODULES_ENABLED=@WITH_MODULES_ENABLED@
AC_ACI_ENABLED=aci@WITH_ACI_ENABLED@
AC_THREADS=threads@BUILD_THREAD@

export AC_bdb AC_hdb AC_ldap AC_ldbm AC_meta AC_monitor AC_relay AC_sql \
	AC_accesslog AC_dynlist AC_pcache AC_ppolicy AC_refint AC_retcode \
	AC_rwm AC_unique AC_syncprov AC_translucent AC_valsort \
	AC_WITH_SASL AC_WITH_TLS AC_WITH_MODULES_ENABLED AC_ACI_ENABLED \
	AC_THREADS

if test ! -x ../servers/slapd/slapd ; then
	echo "Could not locate slapd(8)"
	exit 1
fi

BACKEND=
CLEAN=no
WAIT=0
KILLSERVERS=yes
PRESERVE=${PRESERVE-no}
USERDATA=no

while test $# -gt 0 ; do
	case "$1" in
		-b | -backend)
			BACKEND="$2"
			shift; shift ;;

		-c | -clean)
			CLEAN=yes
			shift ;;

		-k | -kill)
			KILLSERVERS=no
			shift ;;

		-p | -preserve)
			PRESERVE=yes
			shift ;;

		-u | -userdata)
			USERDATA=yes
			shift ;;

		-w | -wait)
			WAIT=1
			shift ;;

		-)
			shift
			break ;;

		-*)
			echo "$USAGE"; exit 1
			;;

		*)
			break ;;
	esac
done

if test -z "$BACKEND" ; then
	for b in bdb ldbm hdb ; do
		if eval "test \"\$AC_$b\" != no" ; then
			BACKEND=$b
			break
		fi
	done
	if test -z "$BACKEND" ; then
		echo "No suitable default database backend configured" >&2
		exit 1
	fi
fi
BACKENDTYPE=`eval 'echo $AC_'$BACKEND`
if test "x$BACKENDTYPE" = "x" ; then
	BACKENDTYPE="unknown"
fi
export BACKEND BACKENDTYPE WAIT KILLSERVERS PRESERVE USERDATA

if test $# = 0 ; then
	echo "$USAGE"; exit 1
fi

# need defines.sh for the definitions of the directories
. $SRCDIR/scripts/defines.sh

SCRIPTDIR="${SRCDIR}/scripts"
SCRIPTNAME="$1"
shift

if test -x "${SCRIPTDIR}/${SCRIPTNAME}" ; then
	SCRIPT="${SCRIPTDIR}/${SCRIPTNAME}"
elif test -x "`echo ${SCRIPTDIR}/test*-${SCRIPTNAME}`"; then
	SCRIPT="`echo ${SCRIPTDIR}/test*-${SCRIPTNAME}`"
elif test -x "`echo ${SCRIPTDIR}/${SCRIPTNAME}-*`"; then
	SCRIPT="`echo ${SCRIPTDIR}/${SCRIPTNAME}-*`"
else
	echo "run: ${SCRIPTNAME} not found (or not executable)"
	exit 1;
fi

if test ! -r ${DATADIR}/test.ldif ; then
	${LN_S} ${SRCDIR}/data ${DATADIR}
fi
if test ! -r ${SCHEMADIR}/core.schema ; then
	${LN_S} ${TOPSRCDIR}/servers/slapd/schema ${SCHEMADIR}
fi

if test -d ${TESTDIR} ; then
	if test $PRESERVE = no ; then
		echo "Cleaning up test run directory leftover from previous run."
		/bin/rm -rf ${TESTDIR}
	elif test $PRESERVE = yes ; then
		echo "Cleaning up only database directories leftover from previous run."
		/bin/rm -rf ${TESTDIR}/db.*
	fi
fi

if test $USERDATA = yes ; then
	if test ! -d userdata ; then
		echo "User data directory (userdata) does not exist."
		exit 1
	fi
	mkdir -p ${TESTDIR}
	cp -R userdata/* ${TESTDIR}
fi

# disable LDAP initialization
LDAPNOINIT=true; export LDAPNOINIT

echo "Running ${SCRIPT}..."
$SCRIPT $*
RC=$?

if test $CLEAN = yes ; then
	echo "Cleaning up test run directory from this run."
	/bin/rm -rf ${TESTDIR}
	echo "Cleaning up symlinks."
	/bin/rm -f ${DATADIR} ${SCHEMADIR}
fi

exit $RC
